"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.extract = void 0;
var strings_1 = require("./helpers/strings");
var Meta = __importStar(require("./metadata"));
var convert = function (_a, command) {
    var keys = _a.keys;
    var comm = command.join(' ');
    var joinedCommand = comm.endsWith(';') ? comm.slice(0, -1) : comm;
    if (!keys)
        return joinedCommand;
    return keys.reduce(function (comm, key, index) {
        var matcher = new RegExp("\\$".concat(key), 'g');
        return comm.replace(matcher, "$".concat(index + 1));
    }, joinedCommand);
};
var create = function (metadata, cmd) {
    var meta = Meta.convert(metadata);
    var converted = convert(meta, cmd);
    var command = (0, strings_1.removeWhitespaces)(converted);
    return { metadata: meta, pp: cmd.join('\n'), command: command };
};
var separateCmds = function (_a, line) {
    var commands = _a.commands, lines = _a.lines;
    var onlyCode = line.trim();
    if (onlyCode.startsWith('--')) {
        return { commands: commands, lines: __spreadArray(__spreadArray([], lines, true), [line], false) };
    }
    else if (onlyCode.endsWith(';')) {
        return { commands: __spreadArray(__spreadArray([], commands, true), [__spreadArray(__spreadArray([], lines, true), [line], false)], false), lines: [] };
    }
    else if (onlyCode.length === 0) {
        return { commands: commands, lines: lines };
    }
    else {
        return { commands: commands, lines: __spreadArray(__spreadArray([], lines, true), [line], false) };
    }
};
var toCommand = function (lines) {
    var acc = [[], []];
    var _a = lines.reduce(Meta.keep, acc), metadata = _a[0], command = _a[1];
    return create(metadata, command);
};
var extract = function (file) {
    var splitted = file.split('\n');
    var acc = { commands: [], lines: [] };
    var _a = splitted.reduce(separateCmds, acc), commands = _a.commands, lines = _a.lines;
    var cmds = lines.length === 0 ? commands : __spreadArray(__spreadArray([], commands, true), [lines], false);
    return cmds.map(toCommand);
};
exports.extract = extract;
//# sourceMappingURL=commands.js.map