"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.keep = exports.convert = void 0;
var strings_1 = require("./helpers/strings");
// prettier-ignore
var handleKeyword = function (keyword, content) {
    switch (keyword) {
        case 'keys': return content.split(',').map(function (k) { return (0, strings_1.camelize)(k.trim()); });
        case 'name': return (0, strings_1.camelize)(content);
        default: return console.warn("Keyword ".concat(keyword, " not implemented."));
    }
};
var convert = function (metadata) {
    var acc = { keys: [] };
    return metadata.reduce(function (acc, val) {
        var _a;
        var _b = val.split(':'), keyword = _b[0], value = _b[1];
        var result = handleKeyword(keyword, value.trim());
        if (!result)
            return acc;
        return __assign(__assign({}, acc), (_a = {}, _a[keyword] = result, _a));
    }, acc);
};
exports.convert = convert;
var keep = function (_a, line) {
    var metadata = _a[0], command = _a[1];
    if (line.trim().startsWith('--')) {
        if (command.length !== 0)
            return [metadata, command];
        var allMetadata = __spreadArray(__spreadArray([], metadata, true), [line.slice(2).trim()], false);
        return [allMetadata, command];
    }
    else {
        var allCommand = __spreadArray(__spreadArray([], command, true), [line], false);
        return [metadata, allCommand];
    }
};
exports.keep = keep;
//# sourceMappingURL=metadata.js.map