"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.convert = void 0;
var fs = __importStar(require("fs"));
var strings_1 = require("./helpers/strings");
var Cmds = __importStar(require("./commands"));
var toQueries = function (client, commands) {
    var acc = {};
    return commands.reduce(function (functions, command_) {
        var _a;
        var metadata = command_.metadata, command = command_.command, pp = command_.pp;
        var name = metadata.name, keys = metadata.keys;
        if (!name)
            return functions;
        var func = function (args) {
            var argsValue = keys.map(function (key) { return args[(0, strings_1.camelize)(key)]; });
            return client.query(command, argsValue);
        };
        func.toString = function () { return pp; };
        func.command = function () { return command; };
        return __assign(__assign({}, functions), (_a = {}, _a[name] = func, _a));
    }, acc);
};
var convert = function (client) { return function (filePath) {
    var file = fs.readFileSync(filePath, 'utf8');
    var commands = Cmds.extract(file);
    var functions = toQueries(client, commands);
    return functions;
}; };
exports.convert = convert;
//# sourceMappingURL=stonebraker.js.map