import * as pg from 'pg';
export declare type Metadata = {
    name?: string;
    keys: string[];
};
export declare type Parts = [string[], string[]];
export declare type Command = {
    metadata: Metadata;
    pp: string;
    command: string;
};
export declare type Commands = {
    commands: string[][];
    lines: string[];
};
export declare type Queries = {
    [name: string]: Query;
};
export declare type Query = {
    (args: {
        [key: string]: any;
    }): Promise<pg.QueryResult<any>>;
    toString(): string;
    command(): string;
};
